package gauntlet;

public class Ball extends Item
{
    protected Direction old;

    public Ball(Grid g, int x, int y, int z)
    {
        super(g,x,y,z);
        mobile = true;
        old = Direction.STOP;
        imageFile = "SmallBall.png";
    }

    public boolean canReceive(Item i)
    {
        return false;
    }

    // Stops only when something gets in its way.
    public Direction move()
    {
        Direction d = motion;
        motion = g.getForce(x,y,z);
        if(motion==d || motion==null || motion==Direction.STOP || baseMove())
        {
            motion = d;
            baseMove();
        }
        if(motion==Direction.STOP && d==Direction.DOWN)
        {
            motion = old;
            baseMove();
        }
        if(motion!=Direction.DOWN) old = motion;
        return motion;
    }

    public void setAttributes(String attrs)
    {
        hasAttributes = true;

        //"dir=[nesw]"
        StringBuilder temp = new StringBuilder(attrs);

        if (attrs.matches(".*dir=[nesw].*")) {
            temp.delete(0,temp.indexOf("dir=")+4);
            temp.delete(1,temp.length());
            switch (temp.charAt(0))
            {
                case 'n':
                    motion = Direction.NORTH;
                    break;
                case 's':
                    motion = Direction.SOUTH;
                    break;
                case 'e':
                    motion = Direction.EAST;
                    break;
                case 'w':
                    motion = Direction.WEST;
                    break;
            }
        }
        //uncomment next line if adding more attributes
        //and don't forget to add similar code to getAttributeString
        //temp = new StringBuilder(attrs);
    }

    public String getAttributeString()
    {
        if ( hasAttributes == false)
            return "";

        String attrStr = "";
        switch (motion) {
            case NORTH:
                attrStr = attrStr + "dir=n,";
                break;
            case EAST:
                attrStr = attrStr + "dir=e,";
                break;
            case SOUTH:
                attrStr = attrStr + "dir=s,";
                break;
            case WEST:
                attrStr = attrStr + "dir=w,";
                break;
        }

        return attrStr;
    }

    public String toString()
    {
        return "s";
    }

}
