package gauntlet;

import com.golden.gamedev.object.Sprite;
import java.awt.image.*;
import com.golden.gamedev.util.ImageUtil;

public class Cursor extends Sprite
{
	public int x,y,z; // position
	public BufferedImage normalImage;
	public BufferedImage selectImage;
	Item item;
	
	public Cursor(int x, int y, int z, BufferedImage normalImage, BufferedImage selectImage)
	{
		//create the sprite
		super();

		//save coords
		this.x = x;
		this.y = y;
		this.z = z;

		//get images for the cursor
		this.normalImage = normalImage;
		this.selectImage = selectImage;
		setImage(normalImage);

		//set screen location
		setLocation(Puzzle.screenX(x,z), Puzzle.screenY(y,z));
	}

	//
	// select(): changes cursor to selection image
	//
	public void select()
	{
		setImage(selectImage);
	}
	
	//
	// normal(): changes cursor to normal image
	//
	public void normal()
	{
		setImage(normalImage);		
	}

	public void updateLocation()
	{
		//set screen location
		setLocation(Puzzle.screenX(x,z), Puzzle.screenY(y,z));
	}

}//end class Cursor
