package gauntlet;

public enum Direction
{
    NORTH (0,-1,0),
    SOUTH (0,1,0),
    EAST (1,0,0),
    WEST (-1,0,0),
    UP   (0,0,1),
    DOWN (0,0,-1),
    STOP (0,0,0);

    public final int x,y,z;

    Direction(int x, int y, int z)
    {
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public Direction opposite()
    {
        switch(this)
        {
            case NORTH:
                return SOUTH;
            case SOUTH:
                return NORTH;
            case EAST:
                return WEST;
            case WEST:
                return EAST;
            case UP:
                return DOWN;
            case DOWN:
                return UP;
        }
        return this;
    }
}
