package gauntlet;

public class Pipe extends Item
{
    Direction a,b;

    public Pipe(Grid g, int x, int y, int z, Direction a, Direction b)
    {
        super(g,x,y,z);
        offsetX = offsetY = -2;
        this.a = a;
        this.b = b;

        if(a==Direction.NORTH || b==Direction.NORTH)
        {
            if(b==Direction.SOUTH || a==Direction.SOUTH)
            {
                imageFile = "HalfPipeNS34.png"; // Vertical
            return;
            }
            if(b==Direction.EAST || a==Direction.EAST)
            {
                imageFile = "TurnNE34.png"; // Northeast
                return;
            }
            if(b==Direction.WEST || a==Direction.WEST)
            {
                imageFile = "TurnNW34.png"; // Northwest
                return;
            }
        }
        if(a==Direction.SOUTH || b==Direction.SOUTH)
        {
            if(b==Direction.EAST || a==Direction.EAST)
            {
                imageFile = "TurnSE34.png"; // Southeast
                return;
            }
            if(b==Direction.WEST || a==Direction.WEST)
            {
                imageFile = "TurnSW34.png"; // Southwest
                return;
            }
        }
        // Otherwise, assume horizontal
        imageFile = "HalfPipeEW34.png";
        return;
    }

    // Only allows entrance through the two open directions or from above.
    public boolean canReceive(Item i)
    {
        return (super.canReceive(i) && (i instanceof Ball) && (
            (i.z > z+1) ||
            (i.x == (x+a.x) && i.y == (y+a.y)) ||
            (i.x == (x+b.x) && i.y == (y+b.y))
        ));
    }

    // Can only exit through the allowed entrances.
    public boolean hasExit(Direction d)
    {
        return (d==a || d==b || d==Direction.UP);
    }

    // If entering from the side, make it follow the pipe.
    // If entering from above, do nothing.
    public boolean receive(Item i)
    {
        // entering via the first opening, make it exit via the second
        if(i.motion==a.opposite())
        {
            i.motion = b;
        }
        // entering via the second opening, make it exit via the first
        else if(i.motion==b.opposite())
        {
            i.motion = a;
        }
        return false;
    }

    public String toString()
    {
        if(a==Direction.NORTH || b==Direction.NORTH)
        {
            if(b==Direction.SOUTH || a==Direction.SOUTH)
            {
                return "|"; // Vertical
            }
            if(b==Direction.EAST || a==Direction.EAST)
            {
                return "b"; // Northeast
            }
            if(b==Direction.WEST || a==Direction.WEST)
            {
                return "d"; // Northwest
            }
        }
        if(a==Direction.SOUTH || b==Direction.SOUTH)
        {
            if(b==Direction.EAST || a==Direction.EAST)
            {
                return "p"; // Southeast
            }
            if(b==Direction.WEST || a==Direction.WEST)
            {
                return "q"; // Southwest
            }
        }
        // Otherwise, assume horizontal
        return "-";
    }
}
