package gauntlet;

public class Ramp extends Item
{
    Direction slope;

    public Ramp(Grid g, int x, int y, int z, Direction downslope)
    {
        super(g,x,y,z);
        slope = downslope;
        switch(slope)
        {
            case NORTH:
                imageFile = "RampN.png";
                break;
            case SOUTH:
                imageFile = "RampS.png";
                break;
            case EAST:
                imageFile = "RampE.png";
                break;
            case WEST:
                imageFile = "RampW.png";
                break;
        }
    }

    public boolean canReceive(Item i)
    {
        if(super.canReceive(i)) return true;
        return ((i.z == z) && (i.x == (x+slope.x)) && (i.y == (y+slope.y)));
    }

    public int slope(Direction d)
    {
        return (d==slope) ? -1 : 0;
    }

    public String toString()
    {
        switch(slope)
        {
            case NORTH:
                return "n";
            case SOUTH:
                return "u";
            case EAST:
                return ")";
            case WEST:
                return "(";
        }
        return null;
    }
}
