package gauntlet;

import java.util.Scanner;
import java.util.regex.MatchResult;

public class Teleport extends Item
{
    Item target;
    String color;
    public boolean animate = true;
    public int animDelay = 400;

    public Teleport(Grid g, int x, int y, int z)
    {
        super(g,x,y,z);
        imageFile = "TransporterAqua.png";
        target = this;
    }

    public boolean receive(Item i)
    {
        // If the target is uncovered, zap the received item over there
        if(target==g.getTop(target.x,target.y))
        {
            g.set(target.x, target.y, target.z+1, i);
            g.set(i.x, i.y, i.z, null);
            i.x = target.x;
            i.y = target.y;
            i.z = target.z+1;
        }
        return false;
    }

    public void setAttributes(String attrs)
    {
        //assign a target
        Scanner s = new Scanner(attrs);
        s.findInLine(".*target=(\\d+),(\\d+),(\\d+).*");
        MatchResult mr = null;
        try {
            mr = s.match();
        } catch (IllegalStateException e) {
            mr = null;
        }
        if (mr != null) {
            int t_x = Integer.parseInt(mr.group(1));
            int t_y = Integer.parseInt(mr.group(2));
            int t_z = Integer.parseInt(mr.group(3));
            target = g.get(t_x,t_y,t_z);
        }

        //assign a color
        s = new Scanner(attrs);
        s.findInLine(".*color=([A-Z][a-z]+)");
        try {
            mr = s.match();
        } catch (IllegalStateException e) {
            mr = null;
        }
        if (mr != null) {
            color = mr.group(1);
            //XXX: check whether the file actually exists
            imageFile = "Transporter"+color+".png";
        }

        //turn animation on/off
        s = new Scanner(attrs);
        s.findInLine(".*anim=([tf][a-z]*)");
        try {
            mr = s.match();
        } catch (IllegalStateException e) {
            mr = null;
        }
        if (mr != null) {
            String anim = mr.group(1);
            if (anim.contains("t")) {
                animate = true;
            } else if (anim.contains("f")) {
                animate = false;
            }
        }

        //set number of milliseconds between frames
        s = new Scanner(attrs);
        s.findInLine(".*animDelay=([0-9]+)");
        try {
            mr = s.match();
        } catch (IllegalStateException e) {
            mr = null;
        }
        if (mr != null) {
            animDelay = Integer.parseInt(mr.group(1));
        }
    }

    public String toString()
    {
        return "t";
    }
}
