package gauntlet;

public class TurboBlock extends Block
{
    Direction d;

    public TurboBlock(Grid g, int x, int y, int z, Direction d)
    {
        super(g,x,y,z,false);
        this.d = d;
        setMobile(false);
    }

    public Direction force()
    {
        return d;
    }

    public String toString()
    {
        switch(d)
        {
            case NORTH:
                return "A";
            case SOUTH:
                return "V";
            case EAST:
                return ">";
            case WEST:
                return "<";
        }
        return super.toString();
    }

    public void setAttributes(String attrs)
    {
        hasAttributes = true;

        if (attrs.matches(".*mobile=[tf].*")) {
            StringBuilder temp = new StringBuilder(attrs);

            temp.delete(0,temp.indexOf("mobile=")+7);
            temp.delete(1,temp.length());
            switch (temp.charAt(0))
            {
               case 't':
                   setMobile(true);
               break;
               case 'f':
                   setMobile(false);
               break;
            }
        }
    }

    public void setMobile(boolean m)
    {
        mobile = m;
        switch(d)
        {
            case NORTH:
                imageFile = (m) ? "TurboBlockMN.png" : "TurboBlockN.png";
                break;
            case SOUTH:
                imageFile = (m) ? "TurboBlockMS.png" : "TurboBlockS.png";
                break;
            case EAST:
                imageFile = (m) ? "TurboBlockME.png" : "TurboBlockE.png";
                break;
            case WEST:
                imageFile = (m) ? "TurboBlockMW.png" : "TurboBlockW.png";
                break;
        }
    }
}
