package gauntlet.menu;

// JFC
import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.event.KeyEvent;

// GTGE
import com.golden.gamedev.*;
import com.golden.gamedev.object.*;


/**
 * Game Credits.
 */
public class Credits extends Menu {


 /****************************************************************************/
 /**************************** CONSTRUCTOR ***********************************/
 /****************************************************************************/

	public Credits(GameEngine parent) {
		super(parent);
	}


 /****************************************************************************/
 /*************************** INIT RESOURCES *********************************/
 /****************************************************************************/

	public void initResources() {
		super.initResources();
	}


 /****************************************************************************/
 /***************************** UPDATE GAME **********************************/
 /****************************************************************************/

	public void update(long elapsedTime) {
		if (keyPressed(KeyEvent.VK_ENTER) || keyPressed(KeyEvent.VK_ESCAPE)) {
			playSound("sounds/MenuSelect.wav");
			finish();
		}
	}


 /****************************************************************************/
 /***************************** RENDER GAME **********************************/
 /****************************************************************************/

	public void render(Graphics2D g) {
		g.drawImage(menu, 0, 0, null);

		
		// draw credits
		g.setColor(Color.RED);
		drawText(g, "GAME CREDITS", 2, false);
		drawText(g, "----------", 3, false);

		drawText(g, "Team:", 5, false);
		drawText(g, "Christoph Otto", 6, false);
		drawText(g, "Ross McClure", 7, false);
		drawText(g, "Mike Matloff", 8, false);
		drawText(g, "Jeff Loiselle", 9, false);
		drawText(g, "Erin Winter", 10, false);

		drawText(g, "Golden T Game Engine", 15, false);
		drawText(g, "Your free Java Game Engine", 16, false);
		drawText(g, "http://www.goldenstudios.or.id/", 17, false);

		// return to main menu
		drawText(g, "Return to Main Menu", 20, true);
	}

	void drawText(Graphics2D g, String text, int line, boolean selected) 
	{
		if (selected) 
		{
			// draw selected rectangle
			g.setColor(Color.YELLOW);
			/*g.drawRoundRect((getWidth()/2) - (font.getWidth(text)/2) - 1,
			 (line*20) - 1,
			 font.getWidth(text) + 2,
			 18,
			 4,
			 4);*/

			g.fillRect((getWidth()/2) - (font.getWidth(text)/2) - 1,
				(line*20) + 3,
				font.getWidth(text) + 2,
				font.getHeight() - 4 );


		}
		g.setColor(Color.RED);

		font.drawString(g, text, GameFont.CENTER,
			0, line*20, getWidth());
	}

}
