package gauntlet.menu;

// JFC
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

// GTGE
import com.golden.gamedev.*;
import com.golden.gamedev.object.*;
import com.golden.gamedev.object.background.*;

import gauntlet.Gumball;


/**
 * Title screen.
 */
public class Title extends Menu
{
 /****************************************************************************/
 /**************************** CONSTRUCTOR ***********************************/
 /****************************************************************************/

	public Title(GameEngine parent)
 	{
		super(parent);
	}


 /****************************************************************************/
 /*************************** INIT RESOURCES *********************************/
 /****************************************************************************/

	public void initResources()
 	{
		super.initResources();

		TOTAL_OPTION = 7;
	}


 /****************************************************************************/
 /***************************** UPDATE GAME **********************************/
 /****************************************************************************/

	public void update(long elapsedTime)
 	{
		super.update(elapsedTime);

		if (keyPressed(KeyEvent.VK_ENTER))
 		{
			playSound("sounds/MenuSelect.wav");

			switch (selectedIndex) 
			{
			//new game
			case 0:
				parent.nextGameID = Gumball.GAME_MODE;
				((Gumball) parent).levelIndex = 0;
				finish();
			break;

			//continue game
			case 1:
				parent.nextGameID = Gumball.GAME_MODE;
				((Gumball) parent).levelIndex = ((Gumball) parent).levelContinue;
				finish();
			break;

			//load level
			case 2:
				new LoadLevel(parent).start();
				finish();
			break;

			//high scores
			case 3:
				new BestTimes(parent).start();
			break;

			// game option
			/*
			case 3:
				new Option(parent).start(); // short cut :)
			break;
			*/

			// controls
			case 4:
				new Control(parent).start();
			break;

			//Help menu
			case 5:
				new Help(parent).start();
			break;
			
			//credits
			case 6:
				new Credits(parent).start();
			break;

			// quit game
			case 7:
				playSound("sounds/MenuSelect.wav");
				parent.nextGameID = Gumball.GAME_EXIT;
				finish();
			break;
			}//end switch

		}//end if

	}//end update()


 /****************************************************************************/
 /***************************** RENDER GAME **********************************/
 /****************************************************************************/

	public void render(Graphics2D g)
 	{
		g.drawImage(title, 0, 0, null);

		// draw menu
		drawText(g, "New Game", 12, (selectedIndex == 0));
		drawText(g, "Continue Game", 13, (selectedIndex == 1));
		drawText(g, "Load Level", 14, (selectedIndex == 2));
		drawText(g, "Best Times", 15, (selectedIndex == 3));
		//drawText(g, "Options", 15, (selectedIndex == 3));
		drawText(g, "Controls", 16, (selectedIndex == 4));
		drawText(g, "Help", 17, (selectedIndex == 5));
		drawText(g, "Credits", 18, (selectedIndex == 6));
		drawText(g, "Quit Game", 19, (selectedIndex == 7));
	}

	void drawText(Graphics2D g, String text, int line, boolean selected) 
	{
		if (selected) 
		{
			// draw selected rectangle
			g.setColor(Color.YELLOW);
			/*g.drawRoundRect((getWidth()/2) - (font.getWidth(text)/2) - 1,
			 (line*20) - 1,
			 font.getWidth(text) + 2,
			 18,
			 4,
			 4);*/

			g.fillRect((getWidth()/2) - (font.getWidth(text)/2) - 1,
				(line*20) + 3,
				font.getWidth(text) + 2,
				font.getHeight() - 4 );


		}
		//g.setColor(new Color(0,0,160));
		g.setColor(Color.BLACK);

		font.drawString(g, text, GameFont.CENTER,
			0, line*20, getWidth());
	}

}//end class Title
